"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function HandleKoaSession2(app, opt) {
    let store = opt.store;
    let key = opt.key || 'koa:sess';
    return function (socket, next) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!socket.handshake.headers.cookie) {
                return next(new Error('no cookie'));
            }
            let ctx = app.createContext(socket.request, socket.response);
            let sid = ctx.cookies.get(key, opt);
            socket.getSession = () => {
                return store.get(sid);
            };
            return next();
        });
    };
}
exports.HandleKoaSession2 = HandleKoaSession2;
function HandleKoaGenericSession(app, opt) {
    let store = opt.store;
    let key = opt.key || 'koa.sid';
    let prefix = opt.prefix || 'koa:sess:';
    return function (socket, next) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!socket.handshake.headers.cookie) {
                return next(new Error('no cookie'));
            }
            let ctx = app.createContext(socket.request, socket.response);
            let sid = ctx.cookies.get(key, opt);
            socket.getSession = () => {
                return store.get(prefix + sid);
            };
            return next();
        });
    };
}
exports.HandleKoaGenericSession = HandleKoaGenericSession;
function HandleKoaSession(app, opt) {
    let store = opt.store;
    let key = opt.key || 'koa:sess';
    return function (socket, next) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!socket.handshake.headers.cookie) {
                return next(new Error('no cookie'));
            }
            let ctx = app.createContext(socket.request, socket.response);
            let sid = ctx.cookies.get(key, opt);
            socket.getSession = () => {
                return store.get(sid);
            };
            return next();
        });
    };
}
exports.HandleKoaSession = HandleKoaSession;
//# sourceMappingURL=index.js.map